#ifndef TWO_CLASS_NLL_CRITERION_INC
#define TWO_CLASS_NLL_CRITERION_INC

#include "Criterion.h"

namespace Torch {

class TwoClassNLLCriterion : public Criterion
{
  public:
    real cst;

    TwoClassNLLCriterion(real cst_=0.);

    virtual void frameForward(int t, real *f_inputs, real *f_outputs);
    virtual void frameBackward(int t, real *f_inputs, real *beta_, real *f_outputs, real *alpha_);
    virtual ~TwoClassNLLCriterion();
};

}

#endif
