#include "Line2D.h"

namespace Torch {

void Line2D::saveXFile(XFile *file)
{
   	P0.saveXFile(file);
   	P1.saveXFile(file);
}

void Line2D::loadXFile(XFile *file)
{
   	P0.loadXFile(file);
   	P1.loadXFile(file);
}

const char *Line2D::sprint()
{
	sprintf(buf_sprint, "((%g, %g) (%g, %g))", P0.x, P0.y, P1.x, P1.y);

	return buf_sprint;
}

void Line2D::draw(Image *image, Color color)
{
   	// Warning: this is not exactly correct as a line is infinite
	// TODO: computes intersections of the line with the image and draw it
	
	image->drawline(P0.x, P0.y, P1.x, P1.y, color);
}

#ifdef HAVE_X11
void Line2D::xdraw(Display *pDisplay, Pixmap pixmap, GC gc, unsigned long color)
{
	XSetForeground(pDisplay, gc, color);

	XDrawLine(pDisplay, pixmap, gc, (int) P0.x, (int) P0.y, (int) P1.x, (int) P1.y);
}
#endif

}
