#include "Canberra.h"

namespace Torch {

//
mCanberra::mCanberra(int n_inputs_) : Metric(n_inputs_)
{
}
	
real mCanberra::measure(real *sample_, real *template_)
{
	real d_ = 0.0;

	for(int i = 0 ; i < n_inputs ; i++)
	{
		real a = sample_[i] - template_[i];
		real b = sample_[i] + template_[i];

		if(a < 0) a = -a;
		
		d_ += a / b;
	}
	
	return d_;
}

}
