#include "MeanVarUnNorm.h"
#include "XFile.h"

namespace Torch {

MeanVarUnNorm::MeanVarUnNorm(MeanVarNorm *norm_)
{
	norm = norm_;
}

void MeanVarUnNorm::unnormalizeSequence(Sequence *sequence, real *mean, real *stdv)
{
  for(int i = 0; i < sequence->n_frames; i++)
  {
    real *ptr_ = sequence->frames[i];
    for(int k = 0; k < sequence->frame_size; k++)
      ptr_[k] = (ptr_[k] * stdv[k]) + mean[k];
  }
}

void MeanVarUnNorm::preProcessInputs(Sequence *inputs)
{
  if(!norm->inputs_mean)
    return;

  unnormalizeSequence(inputs, norm->inputs_mean, norm->inputs_stdv);
}

void MeanVarUnNorm::preProcessTargets(Sequence *targets)
{
  if(!norm->targets_mean)
    return;

  unnormalizeSequence(targets, norm->targets_mean, norm->targets_stdv);
}

MeanVarUnNorm::~MeanVarUnNorm()
{
}

}
