#include "Metric.h"

namespace Torch {

real scalarProduct(int n_inputs, real *x, real *y)
{
	real s = 0.0;

	for(int i = 0 ; i < n_inputs ; i++)
		s += x[i] * y[i];
	
	return s;
}

Metric::Metric(int n_inputs_)
{
   	n_inputs = n_inputs_;
	
	addBOption("verbose", &verbose, false, "verbose"); 
}
	
//
mCityBlock::mCityBlock(int n_inputs_) : Metric(n_inputs_)
{
}
	
real mCityBlock::measure(real *sample_, real *template_)
{
	real d_ = 0.0;

	for(int i = 0 ; i < n_inputs ; i++)
	{
		real z = sample_[i] - template_[i];
		d_ += fabs(z);
	}
	
	return d_;
}

//
mEuclidean::mEuclidean(int n_inputs_) : Metric(n_inputs_)
{
}
	
real mEuclidean::measure(real *sample_, real *template_)
{
	real d_ = 0.0;

	for(int i = 0 ; i < n_inputs ; i++)
	{
		real z = sample_[i] - template_[i];
		d_ += z * z;
	}
	
	return sqrt(d_);
}

}
