#include "StandardCovariance.h"

namespace Torch {

//
mStdCovariance::mStdCovariance(int n_inputs_) : Metric(n_inputs_)
{
}
	
real mStdCovariance::measure(real *sample_, real *template_)
{
	real a, b, c;

	a = scalarProduct(n_inputs, sample_, template_);
	b = scalarProduct(n_inputs, sample_, sample_);
	c = scalarProduct(n_inputs, template_, template_);
	   
	return 1.0 - a / sqrt(b) * sqrt(c);
}

}
