#include "FaceDetectGTMeasurer.h"

namespace Torch {

FaceDetectGTMeasurer::FaceDetectGTMeasurer(FaceModel *facemodel_, bool oneface_)
{
	oneface = oneface_;
	facemodel = facemodel_;
	n_faces = 0;
	l_eyes = NULL;
	r_eyes = NULL;

	if(facemodel == NULL)
		error("Invalid face model.");
}
	
void FaceDetectGTMeasurer::loadXFile(XFile *file)
{
	if(l_eyes != NULL)
		allocator->free(l_eyes);

	if(r_eyes != NULL)
		allocator->free(r_eyes);

	if(oneface)
	{
		n_faces = 1;
                if(verbose) message("Oneface");
	}
	else
	{
		file->scanf("%d", &n_faces);
                if(verbose) message("%d faces in the posfile", n_faces);
                if(n_faces <=0 ) error("Incorrect value for n_faces. Exit.");
	}
		
	l_eyes = (sPoint2D *) allocator->alloc(n_faces*sizeof(sPoint2D));
	r_eyes = (sPoint2D *) allocator->alloc(n_faces*sizeof(sPoint2D));

	for(int i=0 ; i<n_faces; i++)
	{
	 	facemodel->loadXFile(file);

                l_eyes[i] = facemodel->getLeye(); 
		r_eyes[i] = facemodel->getReye(); 

                if(verbose) message(" + Eyes (%.1f-%.1f) - (%.1f-%.1f)", l_eyes[i].x, l_eyes[i].y, r_eyes[i].x, r_eyes[i].y);
	}
}

FaceDetectGTMeasurer::~FaceDetectGTMeasurer()
{
	if(l_eyes != NULL)
	{
		allocator->free(l_eyes);
		l_eyes = NULL;
	}

	if(r_eyes != NULL)
	{
		allocator->free(r_eyes);
		r_eyes = NULL;
	}
}

}
