#ifndef HISTOEQUAL_SMOOTH_IMAGE_PREPROCESS_INC
#define HISTOEQUAL_SMOOTH_IMAGE_PREPROCESS_INC

#include "PreProcessing.h"
#include "ipHistoEqual.h"
#include "ipSmoothGaussian3.h"

namespace Torch {

/** This class is designed to normalize an image by histogram equlization and smoothing
 
    @author Sebastien Marcel (marcel@idiap.ch)
    \Date
    @version 2.0
    @since 2.0
*/
class HistoEqualSmoothImagePreProcessing : public PreProcessing
{
public:
	/// width of the input image
	int width;

	/// height of the input image
	int height;

	/// number of inputs
	int n_inputs;

	/// normalization
	ipCore *enhancing;

	/// smoothing
	ipCore *smoothing;
		
	///
	HistoEqualSmoothImagePreProcessing(int width_, int height_);
	
	/// computes the image normalization of the input image in #inputs_# and stores it in #inputs_#
	virtual void preProcessInputs(Sequence *inputs_);
		
	///
	virtual void preProcessTargets(Sequence *targets_);
	
	///
	virtual ~HistoEqualSmoothImagePreProcessing();
};

}

#endif
